Bug 957422 - (tea) Review Request: tea - A text editor with hundreds of features
Review Request: tea - A text editor with hundreds of features
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
unspecified Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
NotReady
:
Depends On:
Blocks: FE-DEADREVIEW qt-reviews
  Show dependency treegraph
 
Reported: 2013-04-28 01:08 EDT by Christopher Meng
Modified: 2016-07-10 08:38 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2016-07-10 08:38:16 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Christopher Meng 2013-04-28 01:08:33 EDT
Spec URL: http://cicku.me/tea.spec
SRPM URL: http://cicku.me/tea-35.0.0-1.fc20.src.rpm
Description: TEA is a powerful and easy-to-use Qt4-based editor with many useful features 
for HTML, Docbook, and LaTeX editing. It features a small footprint, 
a tabbed layout engine, support for multiple encodings, code snippets, 
templates, customizable hotkeys, an "open at cursor" function for HTML files 
and images, miscellaneous HTML tools, preview in external browser, string 
manipulation functions, Morse-code tools, bookmarks, syntax highlighting, 
and more.
Fedora Account System Username: cicku
Comment 1 Eugene A. Pivnev 2013-04-29 13:05:00 EDT
Swap with https://bugzilla.redhat.com/show_bug.cgi?id=957333
Comment 2 Eugene A. Pivnev 2013-04-29 13:08:21 EDT
Please add koji builds for target systems.
Comment 3 Eugene A. Pivnev 2013-04-29 13:12:33 EDT
Oops... You need sponsor.
Comment 4 Christopher Meng 2013-04-29 22:52:42 EDT
(In reply to comment #3)
> Oops... You need sponsor.

It doesn't matter. Someone will sponsor me.

http://koji.fedoraproject.org/koji/taskinfo?taskID=5316087
Comment 5 Eugene A. Pivnev 2013-04-30 04:10:30 EDT
Ok, let's go.
Comment 6 Eugene A. Pivnev 2013-04-30 06:28:22 EDT
Short pre-review:

= Errors =
* Remove gcc-c++ from BR: https://fedoraproject.org/wiki/Packaging:Guidelines?rd=Packaging/Guidelines#Exceptions_2
* Source0: double //
* Use lang files: https://fedoraproject.org/wiki/Packaging:Guidelines?rd=Packaging/Guidelines#Handling_Locale_Files)
* %doc: images/ not used anywhere
* licensecheck errors (incorrect FSF address)
* precompiled translations (*.qm) in sources. Delete them and recreate witj lrelease.
* PREFIX=%{_bindir} is not used.

= Issues =
* Koji builds for target distros.
* change *-devel to pkgconfig(*) where it is possible (pkgconfig(QtGui), pkgconfig(aspell), pkgconfig(hunspell), pkgconfig(libpng)).
* src.pro does not provides "make release".

Now I want to explore bundled quazip, zlib, zip/unzip.
Comment 7 Eugene A. Pivnev 2013-04-30 06:35:51 EDT
(In reply to comment #6)
> * Use lang files:
> https://fedoraproject.org/wiki/Packaging:Guidelines?rd=Packaging/
> Guidelines#Handling_Locale_Files)

Oops, sorry - tea uses compiled-in translations.
Comment 8 Eugene A. Pivnev 2013-04-30 06:48:14 EDT
manual/* are part of *.qrc - so there is no sense to put them into %doc.
Comment 9 Christopher Meng 2013-04-30 08:13:48 EDT
(In reply to comment #6)
> Short pre-review:
> 
> = Errors =
> * Remove gcc-c++ from BR:

Fixed(But in fact I haven't installed it yet before building it, I've groupinstall development tools)


> * Source0: double //

Oh, Fixed.


> * %doc: images/ not used anywhere

It's used by manuals, why should it be removed? After running the program I don't see a builtin manuals.


> * licensecheck errors (incorrect FSF address)

Where? I've compared with gpl.txt and found everything is same.

Or did I missed something?

> * PREFIX=%{_bindir} is not used.

No. If it's nothing the program will be installed to /usr/local/bin which is even worser.

> 
> = Issues =
> * Koji builds for target distros.

Later.

> * change *-devel to pkgconfig(*) where it is possible (pkgconfig(QtGui),
> pkgconfig(aspell), pkgconfig(hunspell), pkgconfig(libpng)).

Why?(Not very understand)

> * src.pro does not provides "make release".
> 

What's make release?


> Now I want to explore bundled quazip, zlib, zip/unzip.

Not bundled I think.
Comment 10 Eugene A. Pivnev 2013-04-30 09:07:17 EDT
(In reply to comment #9)
> Fixed(But in fact I haven't installed it yet before building it, I've
> groupinstall development tools)

I know. But this is rule :-(

> > * licensecheck errors (incorrect FSF address)
> 
> Where? I've compared with gpl.txt and found everything is same.

http://www.fsf.org/about/contact/ is right address.

> > * PREFIX=%{_bindir} is not used.
> 
> No. If it's nothing the program will be installed to /usr/local/bin which is
> even worser.

And what is it?
"install -p -D -m 755 bin/%{name} %{buildroot}%{_bindir}/%{name}"

> > * change *-devel to pkgconfig(*) where it is possible (pkgconfig(QtGui),
> > pkgconfig(aspell), pkgconfig(hunspell), pkgconfig(libpng)).
> 
> Why?(Not very understand)

This is issue - not bug.
Using pkgconfig() make spec "packagename-independent".
You don't know how these packages will be named in next Fedora release or EL.

> > * src.pro does not provides "make release".
> What's make release?

"Make release" provides compiling without debug information. "Make debug" - with it.
Just add "CONFIG += debug_and_release" to src.pro
This is issue too - not a bug.
Comment 11 Eugene A. Pivnev 2013-04-30 09:26:04 EDT
(In reply to comment #9)
> > * Koji builds for target distros.
> Later.

This is 10-sec action:
for i in f17 f18 f19 rawhide; do koji build --scratch $i <srpm>; done

Another usual tool - fedore-review:
fedora-review -r -n <srpm>
Comment 12 Eugene A. Pivnev 2013-04-30 11:43:28 EDT
So - last part of preview - 3rd parties.
If they are not modified - you must delete them and replace with linking to shared ones.

minizip: ioapi.* zip.* unzip.*
quazip: qua*.*
zlib: zconf.h zlib.h
Comment 13 Christopher Meng 2013-05-01 04:25:37 EDT
(In reply to comment #10)
> And what is it?
> "install -p -D -m 755 bin/%{name} %{buildroot}%{_bindir}/%{name}"

Oh..Forgot to remove it...

> > > * change *-devel to pkgconfig(*) where it is possible (pkgconfig(QtGui),
> > > pkgconfig(aspell), pkgconfig(hunspell), pkgconfig(libpng)).
> > 
> > Why?(Not very understand)
> 
> This is issue - not bug.
> Using pkgconfig() make spec "packagename-independent".
> You don't know how these packages will be named in next Fedora release or EL.

I'll leave these things as I can know the next names ;)

> "Make release" provides compiling without debug information. "Make debug" -
> with it.
> Just add "CONFIG += debug_and_release" to src.pro
> This is issue too - not a bug.

Let's fix bugs first, for such "issues" I think I can handle them later.

> This is 10-sec action:
> for i in f17 f18 f19 rawhide; do koji build --scratch $i <srpm>; done
> Another usual tool - fedore-review:
> fedora-review -r -n <srpm>

I have to say fedora-review doesn't work on my machine, I tried to fix it. So...(In fact I also want to review your package)

> So - last part of preview - 3rd parties.
> If they are not modified - you must delete them and replace with linking to 
> shared ones.
> minizip: ioapi.* zip.* unzip.*
> quazip: qua*.*
> zlib: zconf.h zlib.h

This means I have to add BR like quazip/minizip-devel and zlib-devel.

Bu now because the program use the bundled ones so a lot of errors come out.

Should I asked upstream or fixed by myself?
Comment 14 Eugene A. Pivnev 2013-05-01 04:33:41 EDT
(In reply to comment #13)
> > So - last part of preview - 3rd parties.
> > If they are not modified - you must delete them and replace with linking to 
> > shared ones.
> > minizip: ioapi.* zip.* unzip.*
> > quazip: qua*.*
> > zlib: zconf.h zlib.h
> 
> This means I have to add BR like quazip/minizip-devel and zlib-devel.
> 
> Bu now because the program use the bundled ones so a lot of errors come out.
> 
> Should I asked upstream or fixed by myself?

You can try both ways.
But
1) developer can refuse to do something (as he rejected my 3 bugreports yesterday).
2) guides _disallow_ to ship libraries that exist in repos.
So - you can try to do (e.g. minizip):
* delete minizip sources
* add required things into src.pro
* update #include (if nesessary)
* try to build and run.
Repeate with next.
Comment 15 Christopher Meng 2013-05-01 05:32:26 EDT
(In reply to comment #14)

Ok.

Besides should I use QMAKE_CFLAGS+="%optflags" QMAKE_CXXFLAGS+="%optflags" QMAKE_STRIP="/bin/true" in build section?(from opensuse guidelines)
Comment 16 Eugene A. Pivnev 2013-05-01 07:41:59 EDT
I don't know.
Use fedora-devel maillist.
Comment 17 Eugene A. Pivnev 2013-05-01 07:42:56 EDT
(In reply to comment #15)
> (In reply to comment #14)
> 
> Ok.
> 
> Besides should I use QMAKE_CFLAGS+="%optflags" QMAKE_CXXFLAGS+="%optflags"
> QMAKE_STRIP="/bin/true" in build section?(from opensuse guidelines)

I think - adding debug_and_relese and "make relase" == QMAKE_STRIP="/bin/true
Comment 18 Kevin Kofler 2013-06-29 17:36:43 EDT
Please fix your Summary, it should say "with hundreds of features", not "with the hundreds of features". ("Hundreds" is a plural indefinite expression, and there is no plural indefinite article in English. It does not make sense to put a definite article ("the") on "hundreds".)
Comment 19 Rex Dieter 2013-09-30 11:50:45 EDT
Resetting review flag, since this got reassigned to nobody.

I'd be happy to pick this review up if the bundling issues get sorted out.
Comment 20 Eugene A. Pivnev 2013-10-01 06:20:30 EDT
(In reply to Rex Dieter from comment #19)
> I'd be happy to pick this review up if the bundling issues get sorted out.

I'm sorry for getting out, but (IMHO):
1. tea need very-very hard work for preparing to Fedora and
2. tea's devel is not contactable.
I tried to ask him to make some changes (like unbundle translations from binary or tune up install paths) and had reply "it's your problem".
I'm sorry again.
Comment 21 Rex Dieter 2013-10-01 13:31:03 EDT
ok, marking NotReady, until the bundling issue(s) are dealt with.
Comment 22 Raphael Groner 2015-10-10 16:57:43 EDT
Tea may be of interest for LXQt, alternatives are JuffEd and Enki.

Is it possible to build Tea with Qt5?

Upstream? http://sourceforge.net/projects/tea-editor

There's also a branch for Gtk, we may consider to package both Qt and Gtk.
Comment 23 Christopher Meng 2015-10-13 03:58:02 EDT
(In reply to Raphael Groner from comment #22)
> Tea may be of interest for LXQt, alternatives are JuffEd and Enki.
> 
> Is it possible to build Tea with Qt5?

It's possible.

> Upstream? http://sourceforge.net/projects/tea-editor
> 
> There's also a branch for Gtk, we may consider to package both Qt and Gtk.

I should upload a new version of this package. And, I haven't read recent bundle guideline debate, so not sure if I can continue.
Comment 24 Kevin Kofler 2015-10-13 08:18:50 EDT
You should unbundle the bundled libraries downstream. If you are unable to do that, then you should let a competent maintainer take over as a submitter.
Comment 25 Raphael Groner 2015-10-13 16:31:52 EDT
- TEA text editor v38.0.0 has license GPLv3+ in COPYING file from its tarball, sourceforge fools us somehow here with GPLv2(+).

- What exactly do you mean with unbundling? From AUTHORS file:
PHP hl module by Boo-boo.

Code from other projects: Diego Iastrubni, Qxt Foundation, Trolltech ASA, Franz Schmid, Adam Rogoyski, Michael Protasov, Angius Fabrizio, Kostya Gancov.

ZIP and Zlib stuff by:
Zlib - (C) 1995-2005 Jean-loup Gailly and Mark Adler
Zip/Unzip -  (C) 1998-2005 Gilles Vollant
QuaZIP - (C) 2005-2007 Sergey A. Tachenov

Some code snippets were taken from qtcentre programming forum.

=> I doubt if we can achieve full unbundling with that. You should disable obviously optional Zip/Zlib support, it's useless and IMHO better usable from outside of any text editor. Static linkage of Qt components is problematic cause it violates at least two guideline aspects: no static linkage allowed and general bundling trouble. I don't know what PHP means here, propably for syntax highlighting?

- README file says we need qmake to bootstrap the build configuration, thought that shouldn't be a big issue.
Comment 26 Raphael Groner 2016-07-10 08:38:16 EDT
No response since several monthes. Closing.

Note You need to log in before you can comment on or make changes to this bug.